#include <Python.h>

#include <stdio.h>
#include "i18n.h"
#include "eval.h"

static PyObject *
test( PyObject *self, PyObject *args ) {

  return Py_BuildValue( "s", "testing" );

}


static PyObject *
PythonSetCubeInfo( PyObject *self, PyObject *args ) {

  cubeinfo ci;
  int nCube = 1;
  int fCubeOwner = -1;
  int fMove = 0;
  int nMatchTo = 0;
  int anScore[ 2 ] = { 0, 0 };
  int fCrawford = 0;
  int fJacoby = 1;
  int fBeavers = 1;
  bgvariation bgv = VARIATION_STANDARD;

  if ( ! PyArg_ParseTuple( args, "|iiii(ii)iiii", 
                           &nCube, &fCubeOwner, &fMove, &nMatchTo, 
                           &anScore[ 0 ], &anScore[ 1 ], &fCrawford, &bgv ) )
    return NULL;

  if ( SetCubeInfo( &ci, nCube, fCubeOwner, fMove, nMatchTo, anScore,
                    fCrawford, fJacoby, fBeavers, bgv ) ) {
    printf( "error in SetCubeInfo\n" );
    return NULL;
  }

  return Py_BuildValue( "{s:i,s:i,s:i,s:i,s:(i,i),"
                        "s:i,s:i,s:i,s:((f,f),(f,f)),s:i}",
                        "cube", ci.nCube,
                        "cubeowner", ci.fCubeOwner,
                        "move", ci.fMove,
                        "matchto", ci.nMatchTo,
                        "score", ci.anScore[ 0 ], ci.anScore[ 1 ],
                        "crawford", ci.fCrawford,
                        "jacoby", ci.fJacoby,
                        "beavers", ci.fBeavers,
                        "gammonprice", 
                        ci.arGammonPrice[ 0 ],
                        ci.arGammonPrice[ 2 ],
                        ci.arGammonPrice[ 1 ],
                        ci.arGammonPrice[ 3 ],
                        "bgv", bgv );

}


PyMethodDef gnubgMethods[] = {

  { "test", test, METH_VARARGS, "Just testing :-)" },

  { "setcubeinfo", PythonSetCubeInfo, METH_VARARGS,
    "Make a cubeinfo struct" },
  { NULL, NULL, 0, NULL }

};

